package tech.sbdevelopment.vehiclesplusconverter;

import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;
import tech.sbdevelopment.vehiclesplusconverter.cmd.ConverterCMD;
import tech.sbdevelopment.vehiclesplusconverter.utils.Version;

public final class VehiclesPlusConverter extends JavaPlugin {
    private static VehiclesPlusConverter instance;

    public static VehiclesPlusConverter getInstance() {
        return instance;
    }

    @Override
    public void onEnable() {
        instance = this;

        if (!Bukkit.getPluginManager().isPluginEnabled("VehiclesPlusPro") || !Bukkit.getPluginManager().isPluginEnabled("VehiclesPlus")) {
            Bukkit.getLogger().severe("Make sure both the v2 and v3 fully load without any errors! Disabling the converter...");
            Bukkit.getPluginManager().disablePlugin(this);
            return;
        }

        Version versionOld = Version.of(Bukkit.getPluginManager().getPlugin("VehiclesPlusPro").getDescription().getVersion());
        if (versionOld.isOlderThan(Version.of("2.4.7.1"))) {
            Bukkit.getLogger().severe("Your VehiclesPlus v2 plugin is too old! Please update to at least v2.4.7.1!");
            Bukkit.getPluginManager().disablePlugin(this);
            return;
        }

        Version versionNew = Version.of(Bukkit.getPluginManager().getPlugin("VehiclesPlus").getDescription().getVersion());
        if (versionNew.isOlderThan(Version.of("3.0.3"))) {
            Bukkit.getLogger().severe("Your VehiclesPlus v3 plugin is too old! Please update to at least v3.0.3!");
            Bukkit.getPluginManager().disablePlugin(this);
            return;
        }

        getCommand("vpconvert").setExecutor(new ConverterCMD());
    }

    @Override
    public void onDisable() {
        instance = null;
    }
}
